class towerofTweens extends Phaser.Scene {
    constructor(){
        super("towerofTweens");
    }


preload ()
    {

    var cx=this.sys.game.canvas.width;
    var cy=this.sys.game.canvas.height


    this.registry.set('musicvolume',0.2);

//    this.halver = 0;


    var progress = this.add.graphics();
    var loadertext = this.add.text(0,200,"something about panties ... loadertext");
    loadertext.setStyle({color: '#000000'});
    
    this.load.on('fileprogress', function (map, value){
        progress.clear();
        progress.fillStyle(0xffffff, 0.5);
        progress.fillRect(0, 270, 800 * value, 60);
    });

    this.load.on('complete', function(){
        progress.destroy();
        loadertext.destroy();
    });

    this.load.image('jogoparts','/media/logos/JoGo_asci.png');

    this.load.audio('daloop','/media/nftyr/loaders/totp/assets/lostdasid.ogg');

    this.load.image('bg','/media/nftyr/loaders/totp/assets/stoneish.png');
//    this.load.image('tur','/media/nftyr/loaders/totp/assets/wall.png');

    this.add.text(0,0,'\"tower of Tweens\" v0.0\nJanes Onderground(Syntax Error/AlleyCat)',menubuttonstyle);

    var skrultext = "Tower of Tweens (Phaser) ... v0.0";

//
    this.skrullzor = this.add.text(cx,320, skrultext,quotationstyle2).setDepth(4); ;
    this.quotation5 = this.add.text(320,330, "make demo, be leet , start with helloworld ...",quotationstyle).setVisible(0);
    this.quotation = this.add.text(cx/4,50, "Tower of Tweens\nTwOnion edition\na.k.a. looking at familiar shiney colours,\nthe Sinezit-miks\nby\nJanes Onderground\nloop\nby\nsilversurfer(?) (c64 HTL cracktro) sliced by MrMalice (the Luke, i am not your Vibert-mix) ...",quotationstyle);//.setVisible(0); //might as well use absolute since its set resolution

    this.skrulled = this.skrullzor.width;

    
}


create (){

	this.bg = this.add.image(0,0,'bg').setOrigin(0,0).setAlpha(0);
    
    var easestrings = [
    
    "Linear",
    "Quadratic.Out",
	"Cubic.Out",
    "Quartic.Out",
    "Quintic.Out",
    "Linear",
    "Sine.Out",
    "Expo.Out",
    "Circular.Out",
    "Elastic.Out",
    "Back.Out",
    "Bounce.Out",
    "Stepped",
    "Quart.easeOut",
    "Quint.easeOut",
    "Sine.easeOut",
    "Expo.easeOut",
    "Circ.easeOut",
    "Back.easeOut",
    "Bounce.easeOut",
    "Quad.easeInOut",
    "Cubic.easeInOut",
    "Quart.easeInOut",
    "Quint.easeInOut",
    "Sine.easeInOut",
    "Expo.easeInOut",
    "Circ.easeInOut",
    "Back.easeInOut",
    "Bounce.easeInOut",
    "Quad.easeIn",
    "Cubic.easeIn",
    "Quart.easeIn",
    "Quint.easeIn",
    "Sine.easeIn",
    "Expo.easeIn",
    "Circ.easeIn",
    "Back.easeIn",
    "Bounce.easeIn",
    "Quad.easeOut",
    "Cubic.easeOut",

    ];

    
    var particles = this.add.particles('jogoparts');
    this.fakeascishitter = particles.createEmitter({
        x: cx *0.5,
        y: cy*0.7,
        angle: { min: -180 , max: 0 },
        speedX: {min :0, max: 400},
        speedY : -100,
        alpha: { start: 1, end: 0},
        gravityX: -150,
        lifespan: {min: 500, max: 7000 },
        scaleX: {start : 1, end: 0.1},
        scaleY: {start: 0.01, end: 4},
    });

    this.time.delayedCall(1000,function(){

        this.fakeascishitter.explode(true);
    },[],this)


    this.bgtune = this.sound.add('daloop');

    this.bgtune.setLoop(true);
    this.bgtune.setVolume(this.registry.values.musicvolume);


    this.steps = [];
    this.stepl = [];
    this.stepm = [];
    this.stepr = [];
    this.backraster = [];
    this.evenbackerraster = [];
    this.backestraster = [];
    this.esl = easestrings.length;

    this.moddle = [];
    this.moddler = [];

    this.time.delayedCall(4000,function(){


        let cl=0;
        for(let l=0;l<easestrings.length;l++){

            this.backraster[l] = this.add.rectangle(0,0,cx,1, c64pa[cl]).setOrigin(0,0);
	        this.stepr[l] = this.add.rectangle(190,15+(l*12)+(l*2),10,12, c64pa[1]).setOrigin(0,0).setAlpha(0.1);
            this.steps[l] = this.add.rectangle(0,15+(l*12)+(l*2),200,12, c64pa[cl]).setOrigin(0,0);
            this.stepl[l] = this.add.rectangle(0,15+(l*12)+(l*2),10,12, c64pa[1]).setOrigin(0,0).setAlpha(0.1);
            this.stepm[l] = this.add.rectangle(190,15+(l*12)+(l*2),10,12, c64pa[1]).setOrigin(0,0);
        
	        this.tweens.add({

		        targets: this.stepm[l],
		        duration: 8000,
		        alpha: 0,
		        ease : easestrings[l],
		        yoyo: true,
		        repeat: -1,
	        });

	        this.tweens.add({

		        targets: this.stepl[l],
		        duration: 500,
		        scale: l,
                ease: 'Bounce.easeInOut',
		        yoyo: true,
		        repeat: -1,
                delay : l * 20
	        });

	        this.tweens.add({

		        targets: this.stepr[l],
		        duration: 500,
		        scale: l,
                ease: 'Elastic.easeInOut',
		        yoyo: true,
		        repeat: -1,
                delay : l * 20
	        });


            this.tweens.add({

		        targets: this.bg,
		        duration : 4000,
		        alpha: 0.1,
		        ease : "Elastic.easeInOut",
		        yoyo: true,
		        repeat: -1
	        });

            this.tweens.add({

		        targets: this.backraster[l],
		        duration: 2500,
		        y: cy,
                ease : "Sine",
		        yoyo: true,
		        repeat: -1,
		        delay : l * 20
	        });

            cl++;
            if(cl>15){cl=0;}
        }

        this.timer = this.time.addEvent({

        delay:2000,
        callback: this.remoddle,
        args: [this],
        repeat : -1,
        });

        this.go=1;
    },[],this)

    this.bgtune.play();

    this.lup = 0;
    this.cydex = 0;
    this.slowdowner = 0;
    this.maxslowmax = 8;
    this.maxslow = 0;
    this.tdelay = 0;

    this.factext = this.add.text(0,cy/2,'factor :' + this.maxslow);
    this.deltext = this.add.text(0,cy/2+10,'delay :' + this.tdelay);
}

update(){

    if(this.go){

        let l2=0;
        for(let l=this.lup;l<this.steps.length;l++){

            this.steps[l].fillColor=cycle[this.cydex][l2];
            this.backraster[l].fillColor=cycle[this.cydex][l2];
            l2++;
            if(l2 == this.steps.length){l2=0};
            
			if(this.stepl[0].x < 100){
				this.stepl[l].fillColor=c64p['darkgrey'];
			}
			if(this.stepl[0].x > 100 && this.stepl[0].x < 300){
				this.stepl[l].fillColor=c64p['grey'];
			}
			if(this.stepl[0].x > 300 && this.stepl[0].x < 500){
				this.stepl[l].fillColor=c64p['lightgrey'];
			}
			if(this.stepl[0].x > 500){
				this.stepl[l].fillColor=c64p['white'];
			}
        }
        if(this.slowdowner != this.maxslow){

            this.slowdowner++;
        }
        else{

            this.lup++;
            if(this.lup == this.steps.length){

                this.lup=0;
                this.cydex++;
                if(this.cydex == cycle.length){this.cydex=0;}
                this.factext.text = 'factor : ' + this.maxslow
                this.deltext.text = 'delay : ' + this.tdelay
            }
            this.slowdowner = 0;
        }
    }
}

remoddle(x){

    for(let l=0;l<x.esl;l++){

		x.moddle[l] =x.tweens.add({

			targets: [x.steps[l],x.stepl[l],x.stepm[l]],
			duration: 998,
			x: 600,
			ease: 'Sine.easeInOut',
			yoyo: true,
			repeat: 0,
			delay : l * x.tdelay,
		});

		x.moddler[l] =x.tweens.add({

			targets: [x.stepr[l]],
			duration: 998,
			x: 890,
			ease: 'Sine.easeInOut',
			yoyo: true,
			repeat: 0,
			delay : l * x.tdelay
		});

	}
	x.tdelay++;
	if(x.tdelay>100){x.tdelay=0;}
}
	
}
